
if (! ('extensions' in window)) {
  window.extensions = new Array();
}

if (! ('aecreations' in window.extensions)) {
  window.extensions.aecreations = new Array();
}

if (! ('deliciousPost' in window.extensions.aecreations)) {
  window.extensions.aecreations.deliciousPost = {};
}
else {
  throw new Error("deliciousPost object already defined");
}


window.extensions.aecreations.deliciousPost = {
  
  handleEvent: function (aEvent)
  {
    var that = extensions.aecreations.deliciousPost;

    if (aEvent.type == "load") {
      that.init();
    }
    else if (aEvent.type == "unload") {
      // Must remove event listener references on unload to prevent
      // memory leaks.
      window.removeEventListener("load", that, false);
      window.removeEventListener("unload", that, false);
      document.getElementById("contentAreaContextMenu")
              .removeEventListener("popupshowing", 
				   that.initContentAreaContextMenu, false);
    }
  },


  init: function ()
  {
    var cxtMenu = document.getElementById('contentAreaContextMenu');
    cxtMenu.addEventListener('popupshowing', this.initContentAreaContextMenu, false);
  },


  initContentAreaContextMenu: function (aEvent)
  {
    var cxtPage = document.getElementById("ae-deliciouspost-context-page");
    var cxtLink = document.getElementById("ae-deliciouspost-context-link");
    cxtPage.setAttribute("hidden", gContextMenu.onLink);
    cxtLink.setAttribute("hidden", !gContextMenu.onLink);
  },


  postToDelicious: function ()
  {
    var url, desc;

    if (gContextMenu && gContextMenu.onLink) {
      var link =  gContextMenu.target;
      url = makeURLAbsolute(document.commandDispatcher.focusedWindow.document.location, link.getAttribute('href'));
      desc = gContextMenu.linkText();
    } 
    else {
      url = window.content.document.location.href;
      desc = window.content.document.title;
    }

    this._postToDelicious(url, desc);
  },


  _postToDelicious: function (aURL, aDescription)
  {
    window.openDialog('chrome://aedeliciouspost/content/submit.xul', '', 
		      'centerscreen,chrome', aURL, aDescription);
  },
};


window.addEventListener('load', extensions.aecreations.deliciousPost, false);
window.addEventListener('unload', extensions.aecreations.deliciousPost, false);


